import '../utils/firestore_helpers.dart';
import '../query_state.dart';

Stream<Map<String, dynamic>> documentQueryGetDoc(QueryState q) {
  return q
      .refDocument()
      .take(1)
      .asyncMap((doc) => doc.get())
      .asyncMap((doc) => q.doc2Data(doc));
}

Stream<Map<String, dynamic>> documentQueryGetDocSnap(QueryState q) {
  final $collection = q.refDocument();

  final $resultResolved = $collection
      .asyncExpand((doc) => documentSnap2Stream(doc))
      .asyncMap((doc) => q.doc2Data(doc));

  return $resultResolved;
}
